package com.sample;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.drools.command.Command;
import org.drools.command.CommandFactory;
import org.drools.persistence.jpa.JPAKnowledgeService;
import org.drools.runtime.StatefulKnowledgeSession;
import org.junit.Assert;
import org.junit.Test;

public class MultiInstanceSubprocessTimerEventTest extends
        JbpmPersistenceTestCase {

    public MultiInstanceSubprocessTimerEventTest() {
        super();
        files = new String[] {
                "com.sample.MultipleInstanceSubprocessTimerEvent.bpmn2",
                "com.sample.MultipleInstanceSubprocessTimerEvent1.bpmn2",
                "com.sample.MultipleInstanceSubprocessTimerEvent2.bpmn2" };
    }

    @Test
    public void test() {
        
        StatefulKnowledgeSession ksession = JPAKnowledgeService
                .newStatefulKnowledgeSession(kbase, null, getEnvironment());
        TrackingProcessEventListener processEvents = new TrackingProcessEventListener();
        ksession.addEventListener(processEvents);        
        
        Map<String, Object> params = new HashMap<String, Object>();
        List<String> clients = new ArrayList<String>();
        clients.add("A");
        clients.add("B");
        params.put("clients", clients);
        
        List<Command<?>> commands = new ArrayList<Command<?>>();
        commands.add(CommandFactory.newStartProcess("com.sample.MultiInstanceSubprocessTimerEvent", params));
        ksession.execute(CommandFactory.newBatchExecution(commands));
        
        try {
            Thread.sleep(3000);
        } catch (Exception e) {
            e.printStackTrace();
        }
        
        Assert.assertTrue(processEvents.wasNodeTriggered("main-script1"));
        Assert.assertTrue(processEvents.wasNodeTriggered("main-multiinstance1"));
        Assert.assertTrue(processEvents.wasNodeTriggered("main-script2"));
        Assert.assertTrue(processEvents.wasNodeTriggered("main-multiinstance2"));
        Assert.assertTrue(processEvents.wasNodeTriggered("main-end"));
    }

}